var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as elements from '@yellicode/elements';
var CSharpTypeNameProvider = /** @class */ (function (_super) {
    __extends(CSharpTypeNameProvider, _super);
    function CSharpTypeNameProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CSharpTypeNameProvider.prototype.getTypeNameForType = function (type, isDataType) {
        if (!type)
            return null;
        if (isDataType) {
            if (elements.isPrimitiveBoolean(type))
                return "bool";
            if (elements.isPrimitiveInteger(type))
                return "int";
            if (elements.isPrimitiveReal(type))
                return "double"; // By default, a real numeric literal on the right side of the assignment operator is treated as double (https://msdn.microsoft.com/en-us/library/b1e65aza.aspx)
            if (elements.isPrimitiveString(type))
                return "string";
            if (elements.isPrimitiveObject(type))
                return "object";
        }
        return _super.prototype.getTypeNameForType.call(this, type, isDataType);
    };
    CSharpTypeNameProvider.canBeNullable = function (typedElement, csTypeName) {
        if (!typedElement || !csTypeName)
            return false;
        // A collection cannot be nullable
        if (elements.isMultiplicityElement(typedElement) && typedElement.isMultivalued()) {
            return false;
        }
        // Check the mapped type name (it could come from a custom TypeNameProvider) 
        switch (csTypeName) { // the following cannot be nullable:
            case 'string':
            case 'System.String':
            case 'object':
            case 'System.Object':
                return false;
        }
        // Check the type itself
        var type = typedElement.type;
        if (!type)
            return false;
        return elements.isEnumeration(type) || elements.isDataType(type); // isDataType includes PrimitiveType      
    };
    return CSharpTypeNameProvider;
}(elements.DefaultTypeNameProvider));
export { CSharpTypeNameProvider };
