var XmlDocUtility = /** @class */ (function () {
    function XmlDocUtility() {
    }
    XmlDocUtility.getXmlDocLineForParameter = function (parameter) {
        if (!parameter.xmlDocSummary)
            return null;
        var commentBodies = XmlDocUtility.joinCommentBodies(parameter.xmlDocSummary);
        return "<param name=\"" + parameter.name + "\">" + commentBodies + "</param>";
    };
    XmlDocUtility.getXmlDocLineForReturnParameter = function (method) {
        if (!method.xmlDocReturns)
            return null;
        var commentBodies = XmlDocUtility.joinCommentBodies(method.xmlDocReturns);
        return "<returns>" + commentBodies + "</returns>";
    };
    XmlDocUtility.getXmlDocLinesForInOutParameters = function (parameters) {
        if (!parameters)
            return [];
        var lines = [];
        parameters.forEach(function (p) {
            var l = XmlDocUtility.getXmlDocLineForParameter(p);
            if (l)
                lines.push(l);
        });
        return lines;
    };
    XmlDocUtility.joinCommentBodies = function (bodies) {
        if (!bodies)
            return '';
        return bodies.join(' ');
    };
    return XmlDocUtility;
}());
export { XmlDocUtility };
