import { RenamingTransform, RenameTargets } from '@yellicode/elements';
import { isReservedKeyword } from './utils';
/**
 * Prefixes reserved C# keywords with a "@". This applies to:
 * - Class names
 * - Interface names
 * - Enumeration names
 * - Attribute names
 * - Operation names
 * - Operation parameter names
 */
export class CSReservedKeywordTransform extends RenamingTransform {
    constructor(targets = RenameTargets.all) {
        super(targets);
    }
    rename(name, target) {
        if (!isReservedKeyword(name))
            return name;
        return `@${name}`;
    }
}
