export class XmlDocUtility {
    static getXmlDocLineForParameter(parameter) {
        if (!parameter.xmlDocSummary)
            return null;
        const commentBodies = XmlDocUtility.joinCommentBodies(parameter.xmlDocSummary);
        return `<param name=\"${parameter.name}\">${commentBodies}</param>`;
    }
    static getXmlDocLineForReturnParameter(method) {
        if (!method.xmlDocReturns)
            return null;
        const commentBodies = XmlDocUtility.joinCommentBodies(method.xmlDocReturns);
        return `<returns>${commentBodies}</returns>`;
    }
    static getXmlDocLinesForInOutParameters(parameters) {
        if (!parameters)
            return [];
        var lines = [];
        parameters.forEach((p) => {
            const l = XmlDocUtility.getXmlDocLineForParameter(p);
            if (l)
                lines.push(l);
        });
        return lines;
    }
    static joinCommentBodies(bodies) {
        if (!bodies)
            return '';
        return bodies.join(' ');
    }
}
